(ns com.aurellem.exp.warp
  (:use (com.aurellem.gb gb-driver vbm items util saves))
  (:use (com.aurellem.run util))
  (:import [com.aurellem.gb.gb_driver SaveState]))


;; special thanks to http://tasvideos.org/2913S.html for revealing
;; 0xD364 as the floor-map warp location


(def mat-warp-address 0xD364)

(defn view-warp-id [warp-id]
  (->> 
   [[] (set-memory (at-mat) mat-warp-address warp-id)]
   (do-nothing 20)
   (play-moves [↓])
   (do-nothing 100)))

(defn iterate-locations [start]
  (dorun
   (map 
    #(do
       (printf "0x%02X\n" %)
       (view-warp-id %)
       (Thread/sleep 10000))
    (range start (inc 0xFF)))))
        

(comment
0x00    pallet-town-home
0x01    viridian-poke-center
0x02    pewter-science-meuseum
0x03    cereluan-dig-house
0x04    lavender-town-poke-center
0x05    vermillion-poke-center
0x06    celedon-department-store            !!!!!!!!!!!
0x07    fuchia-mart
0x08    cinnibar-mansion
0x09    elite-four-HQ
0x0A    saffron-mimic-house
0x0B    CRASHING GLITCH
0x0C    route-1-inside-junk
0x0D    diglett-cave-vermillion-side
0x0E    GLITCH
0x0F    poke-center-outside-mt-moon
0x10    cereullean->saffron
0x11    GLITCH
0x12    saffron->celadon
0x13    saffron->lavendar
0x14    GLITCH 
0x15    poke-center-by-rock-tunnel
0x16    vermillion->lavender
0x17    lavender->fuchia
0x18    GLITCH
0x19    GLITCH
0x1A    unknown
0x1B    cycling-road->celadon
0x1C    GLITCH
0x1D    cycling-road->fuschia
0x1E    surfing-house
0x1F    seafom-island-cinnabar-side
0x20    GLITCH
0x21    indigo-plateu-gate
0x22    plateau-path-start
0x23    GLITCH
0x24    bills-house
0x25    house-again
0x26    stairs-to-house
0x27    gary's-house
0x28    oak's-lab
0x29    poke-center-unknown
0x2A    inside-viridian-mart
0x2B    viridian-school-house
0x2C    unknown
0x2D    viridian-gym
0x2E    diglett's-cave-unknown-side
0x2F    glitched-viridian-forest-entrance
0x30    unknown
0x31    unknown
0x32    unknown
0x33    viridian-forest-pewter-side
0x34    pewter-meuseum-first-floor
0x35    pweter-meuseum-second-floor
0x36    pewter-gym
0x37    unknown-house
0x38    unknown-mart
0x39    unknown-house
0x3A    inside-pewter-poke-center
0x3B    inside-mt-moon-entrance
0x3C    mt-moon-unknown
0x3D    mt-moon-unknown
0x3E    inside-dig-house-cereulan?
0x3F    inside-bulbasaur-house-cerulean
0x40    unknown-poke-center
0x41    cereulan-gym
0x42    inside-bike-shop
0x43    unknown-mart
0x44    unknown-poke-center
0x45    inside-dig-house-cereulan?
0x46    unknown-guard-path
0x47    unknown-undeground-path-entrance
0x48    unknown-house
0x49    unknown-undeground-path-entrance
0x4A    unknown-undeground-path-entrance
0x4B    unknown-undeground-path-entrance
0x4C    unknown-guard-path
0x4D    unknown-undeground-path-entrance
0x4E    unknown-undeground-path-entrance
0x4F    unknown-guard-path
0x50    unknown-undeground-path-entrance
0x51    unknown-poke-center
0x52    mt-moon-unknown
0x53    inside-power-plant-start
0x54    unknown-guard-path
0x55    diglet's-cave-vermillion-entrange
0x56    unknown-2nd-floor-guard-path
0x57    unknown-guard-path
0x58    inside-bill's-house
0x59    unknown-poke-center
0x5A    inside-pokemon-fan-club
0x5B    unknown-mart
0x5C    unknown-gym?
0x5D    unknown-house
0x5E    s.s.anne-catwalk
0x5F    s.s.anne-entrance
0x60    unknown-ss-anne-door
0x61    unknown-ss-anne
0x62    unknown-ss-anne
0x63    ss-anne-bow
0x64    ss-anne-cafeteria
0x65    ss-anne-inside-captian's-room
0x66    ss-anne-inside-room
0x67    ss-anne-inside-room
0x68    ss-anne-inside-room
0x69    CRASHING GLITCH
0x6A    CRASHING GLITCH
0x6B    CRASHING GLITCH
0x6C    moltres-cave-entrance
0x6D    CRASHING GLITCH
0x6E    CRASHING GLITCH
0x6F    CRASHING GLITCH
0x70    CRASHING GLITCH
0x71    unknown-ss-anne
0x72    CRASHING GLITCH
0x73    CRASHING GLITCH
0x74    CRASHING GLITCH
0x75    CRASHING GLITCH
0x76    elite-four-hall-of-fame
0x77    unknown-inside-underground-tunnel
0x78    unknown
0x79    unknown-inside-underground-tunnel
0x7A    unknown
0x7B    unknown-celadon-dept-store-floor                    !
0x7C    unknown-celadon-dept-store-floor                    !
0x7D    unknown-celadon-dept-store-floor                    !
0x7E    celedon-dept-roof                                   !
0x7F    celadon-dept-elevator
0x80    celadon-pokemon-mansion-first-floor
0x81    celadon-pokemon-mansion-second-floor
0x82    celadon-pokemon-mansion-third-floor(computers)
0x83    celadon-pokemon-mansion-boring-roof
0x84    celadon-pokemon-mansion-eevee-room
0x85    unknown-poke-center
0x86    inside-celadon-gym
0x87    inside-celadon-game-corner
0x88    unknown-celadon-dept-store-floor                    !
0x89    celadon-game-corner-prize-claim
0x8A    celadon-cafeteria
0x8B    celadon-rocket-house
0x8C    unknown-poke-center (maybe celadon?)
0x8D    unknown-poke-venter (maybe celadon hotel?)
0x8E    unknown-pokemon-tower
0x8F    unknown-pokemon-tower
0x90    unknown-pokemon-tower
0x91    unknown-pokemon-tower
0x92    unknown-pokemon-tower
0x93    unknown-pokemon-tower
0x94    unknown-pokemon-tower
0x95    inside-fiji's-house
0x96    unknown-mart
0x97    unknown-house
0x98    unknown-mart
0x99    unknown-house
0x9A    unknown-poke-center
0x9B    inside-game-warden's-house
0x9C    inside-safari-zone-gate
0x9D    vermillion-gym
0x9E    unknown-fuscia
0x9F    unknown-cave
0xA0    unknown-cave
0xA1    unknown-moltres-cave
0xA2    unknown-seafoam-cave
0xA3    unknown-fishing-guru-house
0xA4    cereulan-house
0xA5    cinibar-mansion-first-floor
0xA6    saffron-gym
0xA7    cinibar-fossil-regen-lab-entrance
0xA8    unknown-house
0xA9    cinibar-fossil-regen-room
0xAA    cinibar-fossil-regen-regen-room
0xAB    unknown-poke-center
0xAC    unknown-mart
0xAD    unknown-mart
0xAE    eilte-four-poke-center
0xAF    glitched-house
0xB0    mimic's-room
0xB1    inside-fighting-dojo
0xB2    saffron-gym
0xB3    unknown-house (lavender?)
0xB4    unknown-mart
0xB5    sliph-co-first-floor
0xB6    unknown-poke-center
0xB7    unknown-house
0xB8    unknown-guard-path
0xB9    unknown-guard-path-2nd-floor
0xBA    unknown-guard-path
0xBB    unknown-guard-path-2nd-floor
0xBC    unknown-house
0xBD    unknown-house (fishing guru?)
0xBE    unknown-guard-path
0xBF    unknown-guard-path-2nd-floor
0xC0    unknown-cave
0xC1    elite-four-gate-entrance
0xC2    unknown-moltres-cave
0xC3    unknown-guard-path-2nd-floor
0xC4    unknown-house
0xC5    unknown-cave
0xC6    unknown-moltres-cave
0xC7    unknown-game-corner
0xC8    unknown-game-corner
0xC9    unknown-game-corner
0xCA    unknown-game-corner
0xCB    game-corner-elevator
0xCC    GLITCH
0xCD    GLITCH
0xCE    GLITCH
0xCF    unknown-silph-co
0xD0    unknown-silph-co
0xD1    unknown-silph-co
0xD2    unknown-silph-co
0xD3    unknown-silph-co
0xD4    unknown-silph-co
0xD5    unknown-silph-co
0xD6    unknown-cinnibar-mansion
0xD7    unknown-cinnibar-mansion
0xD8    unknown-cinnibar-mansion
0xD9    unknown-safari-zone
0xDA    unknown-safari-zone
0xDB    unknown-safari-zone
0xDC    unknown-safari-zone
0xDD    unknown-safari-zone-rest-room
0xDE    safari-zone-surf-room
0xDF    unknown-safari-zone-rest-room
0xE0    unknown-safari-zone-rest-room
0xE1    unknown-safari-zone-rest-room
0xE2    unknown-mewtwo-cave
0xE3    unknown-mewtwo-cave
0xE4    mewtwo-cave-entrance
0xE5    unknown-house
0xE6    cereulan-badge-description-room
0xE7    CRASHING GLITCH
0xE8    unknown-cave
0xE9    unknown-silph-co
0xEA    unknown-silph-co
0xEB    silph-co-boring-top-floor
0xEC    silph-co-elevator
0xED    GLITCH
0xEE    GLITCH
0xEF    GLITCH
0xF0    GLITCH
0xF1    GLITCH
0xF2    GLITCH
0xF3    GLITCH
0xF4    GLITCH
0xF5    loreli-room
0xF6    bruno-room
0xF7    agatha-room
0xF8    inside-surfing-room
0xF9    GLITCH (dark)
0xFA    GLITCH (dark)
0xFB    CRASHING GLITCH
0xFC    GLITCH (dark)
0xFD    CRASHING GLITCH 
0xFE    CRASHING GLITCH
0xFF    CRASHING GLITCH    
   

)